#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_LENGTH 100

// Funkcia na kontrolu, či sú dva znaky pár skob
int isMatching(char opening, char closing) {
    return (opening == '{' && closing == '}') ||
           (opening == '[' && closing == ']') ||
           (opening == '(' && closing == ')') ||
           (opening == '<' && closing == '>');
}

int main() {
    char input[MAX_LENGTH + 1];
    char stack[MAX_LENGTH];
    int top = -1; // Index pre vrchol zásobníka
    int position = 0; // Pozícia aktuálneho znaku
    int hasBrackets = 0; // Flag pre kontrolu prítomnosti zátvoriek

    // Čítanie reťazca
    printf("Zadajte kód (maximálne 100 znakov): ");
    fgets(input, sizeof(input), stdin);
    
    // Odstránenie znaku nového riadku, ak je prítomný
    input[strcspn(input, "\n")] = 0;

    // Kontrola dĺžky reťazca
    if (strlen(input) > MAX_LENGTH) {
        printf("Chyba: dĺžka reťazca presahuje 100 znakov.\n");
        return 1;
    }

    printf("Načítané: %s\n", input);

    // Prechod cez každý znak reťazca
    for (int i = 0; i < strlen(input); i++) {
        char current = input[i];
        position++;

        // Ak je aktuálny znak otváracia zátvorka, vložíme ju do zásobníka
        if (current == '{' || current == '[' || current == '(' || current == '<') {
            stack[++top] = current; // Zvýšiť top a vložiť zátvorku do zásobníka
            hasBrackets = 1; // Zaznamenaj, že zátvorky existujú
        } 
        // Ak je aktuálny znak zatváracia zátvorka
        else if (current == '}' || current == ']' || current == ')' || current == '>') {
            // Ak je zásobník prázdny, je to chyba
            if (top == -1) {
                printf("Neočekávaný znak %c na %d, očakávaná otváracia zátvorka.\n", current, position);
                return 1;
            }

            // Ak zátvorky nesúhlasia, je to chyba
            if (!isMatching(stack[top--], current)) {
                printf("Prekrývajúca sa zátvorka %c na %d, očakávaná %c.\n", current, position, 
                       (current == '}') ? '{' : (current == ']') ? '[' : 
                       (current == ')') ? '(' : '<');
                return 1;
            }
        }
    }

    // Ak zostali otvorené zátvorky v zásobníku, je to chyba
    if (top != -1) {
        printf("Neočekávaný koniec vstupu, očakávaná zatváracia zátvorka pre %c.\n", stack[top]);
        return 1;
    }

    // Kontrola, či existujú nejaké zátvorky
    if (hasBrackets) {
        printf("Všetky zátvorky sú v poriadku\n");
    } else {
        printf("Všetky zátvorky sú v poriadku, žiadne zátvorky neboli nájdené.\n");
    }

    return 0;
}
